SP1 Software Release 4.1.2
==========================

Overview
--------

This software release comprises the following subprojects:

* `libvisiontransfer`: The API for communicating with the SP1 stereo
  vision system.

* `spcom`: The SpCom application provides a live display of the SP1's
  processing results, or for transmitting input image data to the SP1.
  This application depends on `libvisiontransfer`.

* `gentl-producer`: A GenICam GenTL compatible producer module. Use this
  module for integrating the SP1 into existing applications that act as
  GenTL consumers.

Please see the respective subdirectories for further documentation.


Installation
------------

Please use CMake to compile the software for Linux or Mac OS X. If you
are using windows, then we recommend to download a pre-compiled binary
release. If you are compiling SpCom, please make sure that you have the
libraries OpenCV and Qt installed.

You can build each submodule separately from their respective
subdirectories. To build all software at once, please enter the following
commands in the top-level directory:

    $ mkdir build
    $ cd build
    $ cmake ..
    $ make

After compilation you can use the applications and libraries directly
from the created subdirectories `bin/` and `lib/`. Alternatively you can
perform a system wide installation. For installation please use the
following command:

    $ sudo make install


Contact
-------

For further information please contact Nerian Vision Technologies at:

Email: service (at) nerian.com  
Website: http://nerian.com

Address:  
Nerian Vision Technologies  
Dr. Konstantin Schauwecker  
Gotenstr. 9  
70771 Leinfelden-Echterdingen  
Germany  
